Foreman - Bug #35658

Ansible fact parser fails to parse Windows facts if they do not contain os_name
10/21/2022 07:36 AM - Evgeni Golov

Status: Closed
Priority: Normal
Assignee: Evgeni Golov
Category: Facts
Target version:
Difficulty: Fixed in Releases: 3.5.0
Triaged: Yes Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/9476
Description
Reported in

https://community.theforeman.org/t/ansible-callback-with-windows-openssh-server-produces-a-500-server-error-internal/25689/33

Log:

2022-10-20T13:23:51 [I|app|d3408894] Started POST "/api/v2/hosts/facts" for 192.168.1.90 at 2022-1
0-20 13:23:51 +0200

2022-10-20T13:23:51 [I|app|d3408894] Processing by Api::V2::HostsController#facts as JSON
2022-10-20T13:23:51 [I|app|d3408894] Parameters: {"name"=>"winlOtest002.testdom.local", "facts"=
>"[FILTERED]", "apiv"=>"v2", "host"=>{"name"=>"winlOtest002.testdom.local"}}

2022-10-20T13:23:52 [I|app|d3408894] Import facts for 'winlOtest002.testdom.local' completed. Adde
d: 100, Updated: 0, Deleted 0 facts

2022-10-20T13:23:52 [W|app|d3408894] Action failed

2022-10-20T13:23:52 [I|app|d3408894] Backtrace for 'Action failed' error (NoMethodError): undefine
d method “tr' for nil:NilClass

d3408894 | Did you mean? try

d3408894 | /usr/share/foreman/app/services/foreman_ansible/operating_system_parser.rb:82:in “os_n
ame'

d3408894 | /usr/share/foreman/app/services/foreman_ansible/operating_system_parser.rb:7:in " opera
tingsystem'

The problem is that Ansible does not report the “ansible_os_name™ and “ansible_distribution” facts when executed without Admin
privileges (see https:/github.com/ansible-collections/ansible.windows/pull/78 and
https://github.com/ansible-collections/ansible.windows/issues/389 for details, but the issue existed before the PR too, just less
obviously).

Associated revisions

Revision 02ea67ce - 10/21/2022 05:28 PM - Evgeni Golov

Fixes #35658 - don't fail parsing Windows facts without os_name
When Ansible runs on Windows without Admin privileges, it will not
report “ansible_os_name’ and “ansible_distribution® facts, as those

can't be read without being Admin. Don't fail to parse facts in this
case and fall back to a generic "Microsoft Windows" name.

History

#1 - 10/21/2022 07:45 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/9476 added

#2 - 10/21/2022 05:28 PM - The Foreman Bot
- Fixed in Releases 3.5.0 added
https://community.theforeman.org/t/ansible-callback-with-windows-openssh-server-produces-a-500-server-error-internal/25689/33
https://github.com/ansible-collections/ansible.windows/pull/78
https://github.com/ansible-collections/ansible.windows/issues/389

#3 - 10/21/2022 06:01 PM - Evgeni Golov
- Status changed from Ready For Testing to Closed

Applied in changeset foreman|02ea67ce72522b7fc8c0de950ba85f7cd7d8ab91.

#4 - 11/28/2022 12:17 PM - Ewoud Kohl van Wijngaarden

- Triaged changed from No to Yes
